#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/videodev.h>

#include "vidiot.h"

int main(int argc, char *argv[])
{
	int fd = open("/dev/video0", O_RDWR);
	struct video_picture vp;
	struct video_window vw;
	static u8 frame[160*120*2];
	struct video v;
	u8 *fp;

	if(fd==-1)
	{
		perror("video0");
		exit(1);
	}


	if(ioctl(fd, VIDIOCGPICT, &vp)==-1)
	{
		perror("get picture params");
		exit(1);
	}

	vp.palette = VIDEO_PALETTE_YUYV;
	vp.depth = 16;

	if(ioctl(fd, VIDIOCSPICT, &vp)==-1)
	{
		perror("set picture params");
		exit(1);
	}

	if(ioctl(fd, VIDIOCGWIN, &vw)==-1)
	{
		perror("get window params");
		exit(1);
	}

	vw.width = 160;
	vw.height = 120;

	if(ioctl(fd, VIDIOCSWIN, &vw)==-1)
	{
		perror("set window params");
		exit(1);
	}

	if(ioctl(fd, VIDIOCGWIN, &vw)==-1)
	{
		perror("get window params again");
		exit(1);
	}

	fprintf(stderr, "Camera %d x %d\n", vw.height, vw.width);

	v.width = 168;
	v.height = 120;

	while(1)
	{
		int y;

		if(read(fd, frame, 120*160*2)!=160*120*2)
		{
			perror("read");
			exit(1);
		}
	
		fp = frame;
	
		for(y=0;y<120;y++)
		{
			int x;
			memcpy(&v.oldrow[y][0], &v.row[y][0], 168);
			memset(&v.row[y][0], 0, 8);
			for(x=0; x<160;x++)
				v.row[y][8+x]=fp[x*2];
			write(1, v.row[y]+8, 160);
			fp += vw.width * 2;
		}
	}
}
