#include <gtk/gtk.h>
#include "vidiot.h"

GtkWidget *window;
GtkWidget *image;
GdkImage *bits;

int visual;

static int make565(unsigned char v)
{
	unsigned short ret;

	ret = (v>>3) | ((v>>2)<<5) | ((v>>3)<<11);
	return ret;
}

static int set_frame(void)
{
	int y,x;
	unsigned short *ptr = bits->mem;
	unsigned char buf[160*120];
	unsigned char *bp = buf;

	read(0, buf, 160*120);

	for(y=0;y<120;y++)
	{
		for(x=0;x<160;x++)
		{
			*ptr++=make565(*bp++);
		}
	}
}

static int draw_row, draw_col;

void set_draw_row(struct video *v, int y)
{
	draw_row = y;
	draw_col = -8;
}

/*
 *	This code is brain dead - its for testing thats all!
 */

void draw_line(struct video *v, int pixels, int color)
{
	while(pixels>0)
	{
		if(draw_col >= 0)
		{
			switch(visual)
			{
				case 8:
					((unsigned char *)(bits->mem))[draw_row*160+draw_col] = color?0xFF:0x00;
					break;
				case 16:
					((unsigned short *)(bits->mem))[draw_row*160+draw_col] = color?0xFFFF:0x0000;
					break;
				case 24:
					memset(bits->mem+(draw_row*160+draw_col)*3, color?0xFF:0x00, 3);
					break;
				case 32:
					((unsigned int *)(bits->mem))[draw_row*160+draw_col] = color?0xFFFFFFFF:0x00000000;
					break;
			}		
		}
		draw_col++;
		pixels--;
	}
}

static void memxor3(unsigned char *p)
{
	*p++^=0xFF;
	*p++^=0xFF;
	*p^=0xFF;
}
	

void draw_xor_line(struct video *v, int pixels, int flip)
{
	while(pixels>0)
	{
		if(draw_col >= 0)
		{
			switch(visual)
			{
				case 8:
					((unsigned char *)(bits->mem))[draw_row*160+draw_col] ^= flip?0xFF:0x00;
					break;
				case 16:
					((unsigned short *)(bits->mem))[draw_row*160+draw_col] ^= flip?0xFFFF:0x0000;
					break;
				case 24:
					if(flip)
						memxor3(bits->mem+(draw_row*160+draw_col)*3);
					break;
				case 32:
					((unsigned int *)(bits->mem))[draw_row*160+draw_col] ^= flip?0xFFFFFFFF:0x00000000;
					break;
			}
		}
		draw_col++;
		pixels--;
	}
}

void draw_update(struct video *v)
{
	gtk_image_set(GTK_IMAGE(image), bits, NULL);
}

gint do_an_image(gpointer data)
{
	videot_decode_progressive(data);
	draw_update(data);
	return TRUE;
}
	
int gtk_setup(int argc, char *argv[], struct video *v)
{
	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "Alan's experiment");
	
	visual = gdk_visual_get_system()->depth;

	bits = gdk_image_new(GDK_IMAGE_FASTEST, gdk_visual_get_system(), 160, 120);
	image = gtk_image_new(bits, NULL);

//	set_frame();

	gtk_container_add(GTK_CONTAINER(window), image);

	gtk_widget_show(image);
	gtk_widget_show(window);

	gtk_timeout_add(1000, (GtkFunction)do_an_image, v);
	gtk_main();
}
