/*
 *	Testing I/O logic
 */
 

#include <stdio.h>
#include "vidiot.h"

static int bytecount = 0;
 
void outbyte(u8 code)
{
	putchar(code);
	bytecount++;
}

void outbuffer(u8 *buffer, int len)
{
	while(len--)
		outbyte(*buffer++);
}

void outeof(void)
{
	fprintf(stderr, "Frame took %d bytes,\n", bytecount);
	bytecount=0;
}

static int draw_row, draw_col;

void set_draw_row(struct video *v, int y)
{
	draw_row = y;
	draw_col = 0;
	printf("\033[%d;0H", y/2);
}

void draw_line(struct video *v, int pixels, int color)
{
	if(draw_row&1)
		return;
	while(pixels>0)
	{
		if(draw_col&1)
			printf("%c", "# "[color]);
		draw_col++;
		pixels--;
	}
}
